#include <QCoreApplication>
#include <QtSql>
#include <QSqlDatabase>

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);

    QSqlDatabase db = QSqlDatabase::addDatabase("QODBC3");
    // 使用DSN方式
    db.setDatabaseName("testdb");       //DSN名称
    // 使用DSN-Less连接方式
    //db.setDatabaseName("DRIVER=/opt/gbase/lib/cli/iclit09b.so;HOST=h01.gbasedbt.com;SERV=9088;PROT=onsoctcp;DLOC=zh_CN.57372;CLOC=zh_CN.57372;DB=testdb;SRVR=gbase01");
    db.setUserName("gbasedbt");         //用户名
    db.setPassword("GBase123$%");       //密码

    bool ok = db.open();//建立数据库连接
    if(!ok){
        qDebug()<<"Can not connect to GBase 8s Database !"<<db.lastError().text();
        return -1;
    }
    qDebug()<<"Connect to GBase 8s Database OK .";
    QSqlQuery query(db);
    query.prepare("drop table if exists tab1");
    bool drop = query.exec();
    if (!drop){
        qDebug()<<"drop table error !";
    }
    qDebug()<<"drop table tab1 success .";
    query.prepare("create table tab1 (id varchar(255), ts datetime year to second default current year to second)");
    bool create = query.exec();
    if (!create){
        qDebug()<<"create table tab1 error !";
    }
    qDebug()<<"create table tab1 success .";
    query.prepare("insert into tab1(id) values('test001')");
    bool insert = query.exec();
    if (!insert){
        qDebug()<<"insert table tab1 error !";
    }
    qDebug()<<"insert table tab1 success .";
    query.prepare("select * from tab1 where id = :id");
    query.bindValue(":id","test001");
    bool select = query.exec();
    if (!select){
        qDebug()<<"select table tab1 error !";
    }
    QSqlRecord rec = query.record();
    while(query.next())
    {
        rec = query.record();
        QString value1 = query.value(0).toString();
        QString value2 = query.value(1).toString();
        qDebug()<<"id:"<<value1<<"\t"<<"ts:"<<value2;
    }

    db.close();

    return ok;
}
